// LibCo is required to compile this library.
import Image;
lib_cfont
{
image _c[];
integer _d[] = new int[6];
string _h = "0123456789ABCDEF";
proc cfinit(Image src, int w, int h, int z)
{
_d[0] = w;
_d[1] = h;
_d[2] = z;
_d[4] = src.getWidth() / w;
_d[5] = src.getHeight() / h;
_d[3] = _d[4] * _d[5];
_c = new Image[_d[3]];
for (int i = 0; i < _d[3]; i++)
{
_c[i] = Image.createImage(src, (i % _d[4]) * _d[0], (i / _d[4]) * _d[1], _d[0], _d[1], 0);
} 
}
proc cfupscale(int sx, int sy)
{
int w = _d[0] * sx;
int h = _d[1] * sy;
int d[] = new int[_d[0] * _d[1]];
int e[] = new int[w * h];
int i, j, x, y, p;
for (int n = 0; n < _d[3]; n++)
{
	_c[n].getRGB(d, 0, _d[0], 0, 0, _d[0], _d[1]);
	for (i = 0; i < _d[0]; i++)
	for (j = 0; j < _d[1]; j++)
	{
		p = d[i + j * _d[0]];
		for (x = i * sx; x < (i + 1) * sx; x++)
		for (y = j * sy; y < (j + 1) * sy; y++)
		e[x + y * w] = p;
	}
	_c[n] = Image.createRGBImage(e, w, h, true);
}
_d[0] = w;
_d[1] = h;
}
/*
cfont escape characters:
\n \r new line
\0..\9  (0 = 10, 1 = 11)
\+*    '*' 
\-*    '*' 
\$** - (00..FF)
*/
proc cfdraw(String s, int x, int y)
{
int i = x, j = y, c, e, t;
for (int n = 0; n < s.length(); n++)
{
c = s.charAt(n);
// esc char
if (c == '\\')
{
n++;
e = s.charAt(n);
c = -1;
if (e == 'n' || e == 'r') { // new line
c = -1;
j += _d[1];
i = x;
} else if (e == '+') {
n++;
i += _d[0] * s.charAt(n);
} else if (e == '-') {
n++;
i -= _d[0] * s.charAt(n);
} else if (e >= '0' && e <= '9') { // tab
t = e - '0';
t = t == 0 ? 10 : t == 1 ? 11 : t;
i = (((i - x) / _d[0] / t) + 1) * _d[0] * t + x;
} else if (e == '$') { // hex
c = _h.indexOf(s.charAt(n+1)) * 16 + _h.indexOf(s.charAt(n+2));
n += 2;
}
}
// if not void
if (c != -1) 
{
if (c >= _d[2] && c < _d[2] + _d[3]) M.G.drawImage(_c[c - _d[2] + 1], i, j, 0);
i += _d[0];
}


}
}

}